/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor okna_obnov.c */

#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "definice.h"
#include "strukturyw.h"
#include "box3.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

void
obnov_nadpis1 (type_uziv * slozka, type_nastaveni * nastaveni)
{
#include "profi/okna-obnov-c-typ.h"
  vymaz_okno (sub_nadpis);
  wattroff2 (sub_nadpis, A_REVERSE);	/* metronom */
/*    mvwprintw2(sub_nadpis, 1, 1,
	       "psani ver %s, Copyright (c) 2002 Petr Blek", VER); */

  mvwprintw2 (sub_nadpis, 1, 1, "Uivatel:");
  mvwprintw2 (sub_nadpis, 2, 1, "Heslo:\t\t ");
  if (strlen (slozka->heslo) != 0)
    wprintw2 (sub_nadpis, "zadno");
  else
    wprintw2 (sub_nadpis, "nezadno");

  wattron2 (sub_nadpis, A_BOLD);
  if (strcmp (slozka->jmeno, ""))
    {
      MVWPRINTW2 (sub_nadpis, 1, 11, "\t %s", slozka->jmeno);
    }
  else
    {
      MVWPRINTW2 (sub_nadpis, 1, 11, "\t %-.20s", getenv ("USER"));
    }
  wattroff2 (sub_nadpis, A_BOLD);

#include "profi/okna-obnov-c-nadpis1.h"

  if (nastaveni->metronom > 0)
    {
      MVWPRINTW2 (sub_nadpis, 1, COLS - 29, "%3i h./min",
		  nastaveni->metronom);
    }
  else
    {
      MVWPRINTW2 (sub_nadpis, 1, COLS - 29, "%s", "--- h./min");
    }

  if (getenv ("TERM") != NULL)
    MVWPRINTW2 (sub_nadpis, 1, COLS - 10, "%-.8s", getenv ("TERM"));
   /**/ obnov_nadpis ();
}

void
obnov_nadpis2 (type_uziv * slozka, type_nastaveni * nastaveni,
	       type_odstavec * odstavec)
{
  vymaz_okno (sub_nadpis);
  wattroff2 (sub_nadpis, A_REVERSE);	/* metronom */
  mvwprintw2 (sub_nadpis, 1, 1, "Uivatel:");
  mvwprintw2 (sub_nadpis, 2, 1, "Lekce:");
  mvwprintw2 (sub_nadpis, 3, 1, "Odstavec:");

  if (nastaveni->metronom > 0)
    {
    MVWPRINTW2 (sub_nadpis, 1, COLS - 29, "%3i h./min",
		  nastaveni->metronom)}
  else
    mvwprintw2 (sub_nadpis, 1, COLS - 29, "--- h./min");

  mvwprintw2 (sub_nadpis, 1, COLS - 15, "dek / znak");
  mvwprintw2 (sub_nadpis, 2, COLS - 29, "Celkem:");
  mvwprintw2 (sub_nadpis, 3, COLS - 29, "V odstavci:");

  wattron2 (sub_nadpis, A_BOLD);
  if (strcmp (slozka->jmeno, ""))
    {
      MVWPRINTW2 (sub_nadpis, 1, 11, "\t %s", slozka->jmeno);
    }
  else
    {
      MVWPRINTW2 (sub_nadpis, 1, 11, "\t %-.20s", getenv ("USER"));
    }

  MVWPRINTW2 (sub_nadpis, 2, 11, "\t %2u / %2u", odstavec->lekce, LEKCE);
  MVWPRINTW2 (sub_nadpis, 3, 11, "\t %2u / %2u", odstavec->akt_odstavec,
	      odstavec->odstavcu);
  MVWPRINTW2 (sub_nadpis, 2, COLS - 16, "%6u /%6u", odstavec->radku,
	      odstavec->znaku);
  MVWPRINTW2 (sub_nadpis, 3, COLS - 16, "%6u /%6u", odstavec->oradek,
	      odstavec->oznaku);

  wattroff2 (sub_nadpis, A_BOLD);
  obnov_nadpis ();
}

void
obnov_nadpis3 (type_uziv * slozka, type_nastaveni * nastaveni,
	       type_odstavec * odstavec, int na_znamku)
{
  vymaz_okno (sub_nadpis);

  wattroff2 (sub_nadpis, A_REVERSE);	/* metronom */
  mvwprintw2 (sub_nadpis, 1, 1, "Uivatel:");
  mvwprintw2 (sub_nadpis, 2, 1, "Test :");
  mvwprintw2 (sub_nadpis, 3, 1, "Pokus:");

  wattron2 (sub_nadpis, A_BOLD);
  if (strcmp (slozka->jmeno, ""))
    {
      MVWPRINTW2 (sub_nadpis, 1, 11, "%s", slozka->jmeno);
    }
  else
    {
      MVWPRINTW2 (sub_nadpis, 1, 11, "%-.20s", getenv ("USER"));
    }
  wattroff2 (sub_nadpis, A_BOLD);

  MVWPRINTW2 (sub_nadpis, 2, 11, "%02i/%02i", odstavec->lekce, TEST);
  if (slozka->napsano_test[odstavec->lekce - 1] < POKUSU && na_znamku)
    {
      wattron2 (sub_nadpis, A_BOLD);
      MVWPRINTW2 (sub_nadpis, 3, 11, "%2i",
		  slozka->napsano_test[odstavec->lekce - 1] + 1);
      wattroff2 (sub_nadpis, A_BOLD);
    }
  if (nastaveni->metronom > 0)
    {
      MVWPRINTW2 (sub_nadpis, 1, COLS - 29, "%3i h./min",
		  nastaveni->metronom);
    }
  else
    {
      mvwprintw2 (sub_nadpis, 1, COLS - 29, "--- h./min");
    }

  mvwprintw2 (sub_nadpis, 1, COLS - 15, "dek / znak");
  MVWPRINTW2 (sub_nadpis, 2, COLS - 16, "%6u /%6u", odstavec->radku,
	      odstavec->znaku);
  wattroff2 (sub_nadpis, A_BOLD);
  obnov_nadpis ();
}


void
obnov_nadpis (void)
{
  box3 (sub_nadpis, ACS_VLINE, ACS_HLINE);
}

void
obnov_informace (void)
{
  /* box3(sub_informace, '|', '-'); */
  box3 (sub_informace, ACS_VLINE, ACS_HLINE);
  mvwprintw2 (sub_informace, 0, 0, "k = konec ");
}

void
obnov_hlavni (void)
{
  box3 (sub_hlavni, ACS_VLINE, ACS_HLINE);
}

void
obnov_psani (void)
{
  box3 (sub_psani, ACS_VLINE, ACS_HLINE);
}

void
obnov_radek1 (char *radek, int i, unsigned int znaku, unsigned int radku,
	      unsigned int chyb, unsigned int cas, int mezernik)
{
  char ukonceni[3];
  int n, uh_min;
  float pchyb;
  char stemp[82];

  memset (ukonceni, '\0', 3);
  ukonceni[0] = (char) UKONCENIRADKU;
  if (mezernik)
    ukonceni[1] = (char) UKONCENIRADKU;

  wattron2 (sub_radek, COLOR_PAIR (COLOR_RADEK_HLAVNI) | A_BOLD);
  vymaz_okno (sub_radek);

  snprintf (stemp, sizeof (stemp) / sizeof (char) - 2, "%s", radek);
  n = strlen (stemp);
  if (stemp[n - 1] == '\n')
    stemp[n - 1] = '\0';
  if (i >= 0 && i < n - 1)
    {
      stemp[80] = stemp[i];
      stemp[81] = '\0';
      stemp[i] = '\0';
      wattron2 (sub_radek, A_BOLD);
      mvwprintw2 (sub_radek, 1, 1, stemp);
      wattron2 (sub_radek, A_REVERSE);
      wprintw2 (sub_radek, stemp + 80);
      wattroff2 (sub_radek, A_REVERSE | A_BOLD);
      wprintw2 (sub_radek, stemp + i + 1);
    }
  else
    {
      mvwprintw2 (sub_radek, 1, 1, stemp);
    }

  wprintw2 (sub_radek, ukonceni);

  wattroff2 (sub_radek, A_BOLD);
  box3 (sub_radek, ACS_VLINE, ACS_HLINE);

  mvwprintw2 (sub_radek, 2, 1, "----^----1");
  n = ((COLS - 5) / 10) - 1;
  if (!(n <= 9))
    n = 9;
  for (i = 0; i < n; i++)
    {
      sprintf (stemp, "----^----%i", i + 2);
      wprintw2 (sub_radek, stemp);
    }

  if (!cas)
    uh_min = 0.0;
  else
    uh_min = (int) (((float) znaku - 10.0 * chyb) / (float) cas * 60.0);

  mvwprintw2 (sub_radek, 0, 3, "      h./min.");

  mvwprintw2 (sub_radek, 0, COLS - 49,
	      " chyb:               dek/znak:       /");

  wattron2 (sub_radek, COLOR_PAIR (COLOR_RADEK_UHOZU));
  MVWPRINTW2 (sub_radek, 0, 4, "%+4i", uh_min);

  pchyb = !znaku ? 0.0 : (float) chyb / znaku * 100.0;
  if (pchyb > 1.00)
    wattron2 (sub_radek, COLOR_PAIR (COLOR_RADEK_CHYBA));
  else
    wattron2 (sub_radek, COLOR_PAIR (COLOR_RADEK_BEZCHYBY));

  wattron2 (sub_radek, A_BOLD);
  MVWPRINTW2 (sub_radek, 0, COLS - 42, "%3u (%5.2f%%)", chyb, pchyb);
  wattroff2 (sub_radek, A_BOLD);

  wattron2 (sub_radek, COLOR_PAIR (COLOR_RADEK_HLAVNI) | A_BOLD);

  MVWPRINTW2 (sub_radek, 0, COLS - 16, "%6u", radku);
  MVWPRINTW2 (sub_radek, 0, COLS - 8, "%6u ", znaku);
  wattroff2 (sub_radek, A_BOLD);
}

void
print_hl (int pocet, ...)
{
  int i;
  va_list ap;
  char *str;
  va_start (ap, pocet);

  move2 (LINES - 1, 0);
  scroll2 (stdscr);
  attron2 (COLOR_PAIR (COLOR_POZADI_HLAVNI));
  for (i = 1; i <= pocet; i++)
    {
      str = va_arg (ap, char *);
      if (str == NULL)
	break;
      printw2 (str);
    }
  va_end (ap);
  tiskni_dle_priority ();
}
