/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor spustlekci.c */

#include <limits.h>
#include <string.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "zobraz_odstavec.h"

static FILE *soubor_l;
static char radek_l[RADEK];


int
inicializuj_lekci (type_uziv * slozka, type_odstavec * odstavec)
{
  char *chybaodst[] = { " PLI MNOHO ODSTAVC\n", "         < OK >" };
  char *chybaodst2[] = { " NENALEZEN DN ODSTAVEC\n", "          < OK >" };
  char *chodst[] = { "         odstavec:\n", "    1 ", "2 ", "3 ", "4 ",
    "5 ", "6 ", "7 ", "8 ", "9 ", "10 ", "11 "
  };
  unsigned int znaku_odstavci[MAXODSTAVEC];
  unsigned int radku_odstavci[MAXODSTAVEC];
  int i;

  if ((soubor_l = fopen (jmeno_lekceXX (odstavec->lekce), "rt")) == NULL)
    {
      print_hl (2, jmeno_lekceXX (odstavec->lekce),
		":  soubor nelze otevt");
      return 1;
    }
/**************************************************************************/
  for (i = 0; i < MAXODSTAVEC; i++)
    {
      znaku_odstavci[i] = 0;
      radku_odstavci[i] = 0;
    }

  odstavec->odstavcu = 0;
  odstavec->znaku = 0;
  odstavec->radku = 0;

  while (!nacti_radek (radek_l, sizeof (radek_l) / sizeof (char), soubor_l))
    {
      if (!strncmp (radek_l, "#odstavec", 9)
	  || !strncmp (radek_l, "#!odstavec", 10))
	{
	  (odstavec->odstavcu)++;
	}
      else if (!odstavec->odstavcu)
	{
	  (void) button (chybaodst2, 2, 1, 4, 28, LINES / 2 - 2,
			 COLS / 2 - 14);
	  return 1;
	}
      else if (strncmp (radek_l, "#konec", 6))
	{
	  (odstavec->radku)++;
	  odstavec->znaku += secti_znaky (radek_l);
	  radku_odstavci[odstavec->odstavcu - 1]++;
	  znaku_odstavci[odstavec->odstavcu - 1] += secti_znaky (radek_l);
	}
      else
	break;
    }
/****************************************************************************/
  if (odstavec->odstavcu > MAXODSTAVEC)
    {
      (void) button (chybaodst, 2, 1, 4, 25, LINES / 2 - 2, COLS / 2 - 12);
      return 1;
    }
  if (odstavec->odstavcu == 0)
    {
      (void) button (chybaodst2, 2, 1, 4, 28, LINES / 2 - 2, COLS / 2 - 14);
      return 1;
    }
/*************************************************************************/
  if ((slozka->napsano_odstavec[odstavec->lekce - 1] < odstavec->odstavcu))
    odstavec->akt_odstavec =
      button (chodst,
	      slozka->napsano_odstavec[odstavec->lekce - 1] + 2,
	      slozka->napsano_odstavec[odstavec->lekce - 1] + 1, 5,
	      30, 7, 12);
  else
    odstavec->akt_odstavec =
      button (chodst, odstavec->odstavcu + 1, odstavec->odstavcu, 5,
	      30, 7, 12);

  if (odstavec->akt_odstavec <= 0)
    return 1;			/* chyba buttonu */

  odstavec->oradek = radku_odstavci[odstavec->akt_odstavec - 1];
  odstavec->oznaku = znaku_odstavci[odstavec->akt_odstavec - 1];


/* nastaveni aktualniho odstavce */
  if (fseek (soubor_l, 0, SEEK_SET))
    {
      perror ("fseek");
      return 1;
    }

  i = 0;

  while (!nacti_radek (radek_l, sizeof (radek_l) / sizeof (char), soubor_l))
    {
      if (!strncmp (radek_l, "#odstavec", 9)
	  || !strncmp (radek_l, "#!odstavec", 10))
	i++;
      if (i == odstavec->akt_odstavec)
	{
	  if (!strncmp (radek_l, "#!", 2))
	    odstavec->mezernik = 0;
	  else
	    odstavec->mezernik = 1;
	  break;
	}
    }

  return 0;
}


/**********************************/
/**********************************/


int
spust_lekci (type_uziv * slozka, type_nastaveni * nastaveni,
	     type_odstavec * odstavec)
{
  unsigned int znak, radku, chyb, vterin;
  int ch;
  type_informace infolekce;

  obnov_nadpis2 (slozka, nastaveni, odstavec);
  znak = radku = chyb = vterin = 0;

  vymaz_okno (sub_psani);

  obnov_radek1
    ("Po zmknut <mezernku> b as a do ukonen odstavce", -1,
     znak, radku, chyb, vterin, odstavec->mezernik);
  print_hl (1,
	    "Psan odstartujete zmknutm <mezernku>, ukonte <BACKSPACE>");

  obnov_psani ();
  tiskni_dle_priority ();

  ch = '\0';
#include "profi/spustlekci-c-zobraz-odstavec.h"
  while (ch != ' ')
    {
      if ((ch == KEY_BACKSPACE) || (ch == 'k'))
	{
	  tiskni_dle_priority ();
	  global_set (g_run, g_run_null);
	  return 1;
	}
      ch = getch3 ();
    }

  global_set (g_run, g_run_l);

  while (!nacti_radek (radek_l, sizeof (radek_l) / sizeof (char), soubor_l))
    {
      if (!strncmp (radek_l, "#odstavec", 9)
	  || !(strncmp (radek_l, "#!odstavec", 10))
	  || !strncmp (radek_l, "#konec", 6))
	break;
      else
	{
	  radku++;
	  if (pis_radek (&vterin,
			 radek_l, radku, &znak, &chyb, odstavec->mezernik, 0))
	    {
	      tiskni_dle_priority ();
	      global_set (g_run, g_run_null);
	      return 1;
	    }
	}
    }

  if (fclose (soubor_l) && (global_get (g_warning) == g_w_ano))
    perror ("fclose");
  global_set (g_run, g_run_null);
  odstavec->oznaku = znak;
  obnov_psani ();
  tiskni_dle_priority ();

  infolekce = informace_o_lekcich (odstavec->lekce, slozka);
  switch (vyhodnot_lekci (slozka, odstavec, infolekce,
			  znamka_lekce (infolekce, odstavec->oznaku, chyb,
					vterin)))
    {
    case 2:			/* dalsi lekce */
      odstavec->lekce = vyber_lekci (slozka, nastaveni, odstavec->lekce,
				     odstavec->lekce + 1);
      if (odstavec->lekce && !inicializuj_lekci (slozka, odstavec))
	(void) spust_lekci (slozka, nastaveni, odstavec);
      return 0;
    case 1:			/* dalsi odstavec */
      if (!inicializuj_lekci (slozka, odstavec))
	(void) spust_lekci (slozka, nastaveni, odstavec);
      return 0;
    default:
      return 0;
    }
  return 0;
}
