/* Copyright (c) 2014 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor zobraz_odstavec.c */
#include <errno.h>
#include "lib.h"
#include "libw.h"
#include "zobraz_odstavec.h"
#include "strukturyw.h"
#include "barvy.h"

static int
getRozmery (int *y, int *x, int *row_min, int *col_min)
{
  getmaxyx2 (sub_psani, *y, *x);
  getbegyx2 (sub_psani, *row_min, *col_min);
  *x -= 2;			//box
  *y -= 2;			//box
  (*row_min)++;
  (*col_min)++;			//okraje
  if (y < 0 || x < 0 || row_min <= 0 || col_min <= 0)
    {
      print_hl (1, "Nepodailo se zjistit velikost okna sub_psani");
      return 0;
    }
  return 1;
}

int
zobraz_odstavec (FILE * soubor, char *radek_o, const size_t size,
		 type_odstavec * odstavec)
{
  WINDOW *zapisnik;
  int ch, y, x, row_min, col_min, line, radek, i, j;

  if (!getRozmery (&y, &x, &row_min, &col_min))
    {
      return '\0';
    }
  radek = odstavec->oradek + 2;

  if ((zapisnik = newpad2 (odstavec->oradek + 2, x)) == NULL)
    {
      print_hl (1, "Nepodailo se otevt okno s obsahem odstavce.");
      if (global_get (g_warning) == g_w_ano)
	perror ("newpad2()");
      return '\0';
    }
  wattron2 (zapisnik, COLOR_PAIR (COLOR_SUB_PSANI) | A_BOLD);
  for (i = 0; i < odstavec->oradek + 2; i++)
    {
      for (j = 0; j < x; j++)
	{
	  mvwprintw2 (zapisnik, i, j, " ");
	}
    }
  wmove2 (zapisnik, 0, 0);
  wprintw2 (zapisnik, "Chystte se pst tento odstavec:");
  wattroff2 (zapisnik, A_BOLD);
    /****** vypis odstavce *******/
  long pos = ftell (soubor);
  j = 2;
  while (!nacti_radek (radek_o, size, soubor))
    {
      if (!strncmp (radek_o, "#odstavec", 9)
	  || !strncmp (radek_o, "#!odstavec", 10)
	  || !strncmp (radek_o, "#konec", 6)
	  || !strncmp (radek_o, "#!konec", 7))
	{
	  break;
	}
      i = strlen (radek_o);
      if (i > 0 && radek_o[i - 1] == '\n')
	{
	  radek_o[i - 1] = '\0';
	}
      mvwprintw2 (zapisnik, j++, 0, radek_o);
    }
  fseek (soubor, pos, SEEK_SET);

    /***** posouvani obsahu odstavce *****/
  line = 0;
  pridej_do_priority_p (1, zapisnik, 0 + line, 0, row_min, col_min,
			row_min + y - 1, col_min + x, stdscr, LINES - 1, 0);

  do
    {
      odeber_z_priority (zapisnik);
      getRozmery (&y, &x, &row_min, &col_min);
      pridej_do_priority_p (1, zapisnik, 0 + line, 0, row_min, col_min,
			    row_min + y - 1, col_min + x, stdscr,
			    LINES - 1, 0);
      obnov_psani ();
      tiskni_dle_priority ();

      ch = getch3 ();
      if (ch == KEY_UP && line != 0)
	line--;
      else if ((ch == KEY_DOWN) && line < radek - y)
	line++;
    }
  while (ch != KEY_BACKSPACE && ch != 'k' && ch != 'K' && ch != ' ');


  odeber_z_priority (zapisnik);
  if (delwin2 (zapisnik) == ERR)
    if (global_get (g_warning) == g_w_ano)
      perror ("delwin()");
  tiskni_dle_priority ();
  return ch;
}
